﻿using System.Windows;

using TestLibrary;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.showDefaultSideMenuButton.Click  += showDefaultSideMenuButton_Click;
            this.showCustomSideMenuButton.Click   += showCustomSideMenuButton_Click;
            this.defaultSideMenuThemeButton.Click += defaultSideMenuThemeButton_Click;
            this.primarySideMenuThemeButton.Click += primarySideMenuThemeButton_Click;
            this.successSideMenuThemeButton.Click += successSideMenuThemeButton_Click;
            this.warningSideMenuThemeButton.Click += warningSideMenuThemeButton_Click;
            this.dangerSideMenuThemeButton.Click  += dangerSideMenuThemeButton_Click;
            this.toggleClosingTypeButton.Click    += toggleClosingTypeButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 디폴트 사이드 메뉴 표시 버튼 클릭시 처리하기 - showDefaultSideMenuButton_Click(sender, e)

        /// <summary>
        /// 디폴트 사이드 메뉴 표시 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void showDefaultSideMenuButton_Click(object sender, RoutedEventArgs e)
        {
            this.defaultSideMenu.Toggle();
        }

        #endregion
        #region 커스텀 사이드 메뉴 표시 버튼 클릭시 처리하기 - showCustomSideMenuButton_Click(sender, e)

        /// <summary>
        /// 커스텀 사이드 메뉴 표시 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void showCustomSideMenuButton_Click(object sender, RoutedEventArgs e)
        {
            this.customSideMenu.Toggle();
        }

        #endregion

        #region DEFAULT 사이드 메뉴 테마 버튼 클릭시 처리하기 - defaultSideMenuThemeButton_Click(sender, e)

        /// <summary>
        /// DEFAULT 사이드 메뉴 테마 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void defaultSideMenuThemeButton_Click(object sender, RoutedEventArgs e)
        {
            this.defaultSideMenu.Theme = SideMenuTheme.Default;
        }

        #endregion
        #region PRIMARY 사이드 메뉴 테마 버튼 클릭시 처리하기 - primarySideMenuThemeButton_Click(sender, e)

        /// <summary>
        /// PRIMARY 사이드 메뉴 테마 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void primarySideMenuThemeButton_Click(object sender, RoutedEventArgs e)
        {
            this.defaultSideMenu.Theme = SideMenuTheme.Primary;
        }

        #endregion
        #region SUCCESS 사이드 메뉴 테마 버튼 클릭시 처리하기 - successSideMenuThemeButton_Click(sender, e)

        /// <summary>
        /// SUCCESS 사이드 메뉴 테마 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void successSideMenuThemeButton_Click(object sender, RoutedEventArgs e)
        {
            this.defaultSideMenu.Theme = SideMenuTheme.Success;
        }

        #endregion
        #region WARNING 사이드 메뉴 테마 버튼 클릭시 처리하기 - warningSideMenuThemeButton_Click(sender, e)

        /// <summary>
        /// WARNING 사이드 메뉴 테마 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void warningSideMenuThemeButton_Click(object sender, RoutedEventArgs e)
        {
            this.defaultSideMenu.Theme = SideMenuTheme.Warning;
        }

        #endregion
        #region DANGER 사이드 메뉴 테마 버튼 클릭시 처리하기 - dangerSideMenuThemeButton_Click(sender, e)

        /// <summary>
        /// DANGER 사이드 메뉴 테마 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void dangerSideMenuThemeButton_Click(object sender, RoutedEventArgs e)
        {
            this.defaultSideMenu.Theme = SideMenuTheme.Danger;
        }

        #endregion

        #region 종료 타입 토글 버튼 클릭시 처리하기 - toggleClosingTypeButton_Click(sender, e)

        /// <summary>
        /// 종료 타입 토글 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void toggleClosingTypeButton_Click(object sender, RoutedEventArgs e)
        {
            this.defaultSideMenu.ClosingType = this.defaultSideMenu.ClosingType == ClosingType.Auto ? ClosingType.Manual : ClosingType.Auto;
        }

        #endregion

        #region 메뉴 버튼 클릭시 처리하기 - menuButton_Click(sender, e)

        /// <summary>
        /// 메뉴 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void menuButton_Click(object sender, RoutedEventArgs e)
        {
            MenuButton menuButton = sender as MenuButton;

            MessageBox.Show(this, $"{menuButton.Text} 메뉴를 클릭했습니다.");
        }

        #endregion
        #region 메뉴 닫기 버튼 클릭시 처리하기 - closeMenuButton_Click(sender, e)

        /// <summary>
        /// 메뉴 닫기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void closeMenuButton_Click(object sender, RoutedEventArgs e)
        {
            this.defaultSideMenu.Hide();
        }

        #endregion
    }
}